/*
 * Copyright (c) 1996 Barton P. Miller
 * 
 * We provide the Paradyn Parallel Performance Tools (below
 * described as Paradyn") on an AS IS basis, and do not warrant its
 * validity or performance.  We reserve the right to update, modify,
 * or discontinue this software at any time.  We shall have no
 * obligation to supply such updates or modifications or any other
 * form of support to you.
 * 
 * This license is for research uses.  For such uses, there is no
 * charge. We define "research use" to mean you may freely use it
 * inside your organization for whatever purposes you see fit. But you
 * may not re-distribute Paradyn or parts of Paradyn, in any form
 * source or binary (including derivatives), electronic or otherwise,
 * to any other organization or entity without our permission.
 * 
 * (for other uses, please contact us at paradyn@cs.wisc.edu)
 * 
 * All warranties, including without limitation, any warranty of
 * merchantability or fitness for a particular purpose, are hereby
 * excluded.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * Even if advised of the possibility of such damages, under no
 * circumstances shall we (or any other person or entity with
 * proprietary rights in the software licensed hereunder) be liable
 * to you or any third party for direct, indirect, or consequential
 * damages of any character regardless of type of action, including,
 * without limitation, loss of profits, loss of use, loss of good
 * will, or computer failure or malfunction.  You agree to indemnify
 * us (and any other person or entity with proprietary rights in the
 * software licensed hereunder) for any and all liability it may
 * incur to third parties resulting from your use of Paradyn.
 */

// $Id: templates0.C,v 1.18 2000/03/18 21:53:59 tikir Exp $
// Generate all the templates in one file.

/*
 * This file (and the other templatesXXX.C files) exist for a single purpose:
 * to explicitly instantiate code for all of the template classes we use.
 * Although the C++ standard dictates that compilers should automatically
 * instantiate all templates (and leaves the details to the implementation),
 * g++ 2.7.2, which we currently use, doesn't do that correctly.  So instead,
 * we use a special compiler switch (-fno-implicit-templates or 
 * -fexternal-templates) which tells g++ not to try and automatically
 * instantiate any templates.  We manually instantiate the templates in this
 * and the other templatesXXX.C files.  If you are porting Paradyn, and are
 * using a compiler that correctly and automatically instantiates its 
 * templates, then you don't need to use any of the templatesXXX.C files (so
 * remove their entries from the appropriate make.module.tmpl file).
 *
 */


#pragma implementation "Pair.h"
#include "util/h/Pair.h"

#pragma implementation "Vector.h"
#include "util/h/Vector.h"

#pragma implementation "Symbol.h"
#include "util/h/Symbol.h"

#include "util/h/String.h"

#include "dyninstAPI/src/symtab.h"
#include "dyninstAPI/src/process.h"
#include "dyninstAPI/src/inst.h"
#include "dyninstAPI/src/instP.h"
#include "dyninstAPI/src/dyninstP.h"
#include "dyninstAPI/src/ast.h"
#include "dyninstAPI/src/util.h"
#include "dyninstAPI/src/Object.h"
#if !defined(BPATCH_LIBRARY) || defined(sparc_sun_sunos4_1_3) || defined(sparc_sun_solaris2_4)
#include "dyninstAPI/src/FunctionExpansionRecord.h"
#include "dyninstAPI/src/LocalAlteration.h"
#endif

template class  vector<pdThread *>;
template class  vector< vector<pdThread *> >;
template class  vector<bool>;
template class  vector<AstNode>;
template class  vector<AstNode *>;
template class  vector<Symbol*>;
template class  vector<Symbol>;
template class  vector<float>;
template class  vector<heapItem*>;
template class  vector<image*>;
template class  vector<instMapping*>;
template class  vector<instPoint *>;
template class  vector<const instPoint *>;
template class  vector<trampTemplate *>;
template class  vector<int>;
template class  vector<instruction>;
#ifndef BPATCH_LIBRARY
template class  vector<metricDefinitionNode *>;
#endif
template class  vector<module *>;
template class  vector<pdmodule *>;
template class  vector<function_base*>;
template class  vector<pd_Function*>;
template class  vector<process*>;
template class  vector<string>;
template class  vector<sym_data>;
template class  vector<unsigned>;
template class  vector<unsigned long>;
template class  vector<long>;
template class  vector<disabledItem>;
template class  vector<addrVecType>;
template class  vector<vector<string> >;
template class  vector<double>;
template class  vector<point *>;
template class  vector<instInstance *>;
template class  vector<returnInstance *>;             //XXX
template class  vector<relocatedFuncInfo *>; 
template class  vector<relocationEntry>;
#if !defined(BPATCH_LIBRARY) || defined(sparc_sun_sunos4_1_3) || defined(sparc_sun_solaris2_4)
template class vector<FERNode>;
template class vector<FERNode*>;
template class vector<LocalAlteration*>;
#endif
